Index: channel.c
===================================================================
RCS file: /usr/cvsroot/asterisk/channel.c,v
retrieving revision 1.216
diff -u -p -r1.216 channel.c
--- channel.c	9 Jul 2005 20:37:59 -0000	1.216
+++ channel.c	10 Jul 2005 21:14:31 -0000
@@ -31,12 +31,6 @@
 #error "You need newer zaptel!  Please cvs update zaptel"
 #endif
 #endif
-#ifdef __FreeBSD__
-#include <strfunc.h>
-#if (!defined(__STRFUNC_H__) && (!defined(STRFUNC_H)))
-#error "Please install the strfunc library located in the ports collection at /usr/ports/devel/libstrfunc"
-#endif
-#endif
 
 #include "asterisk.h"
 
@@ -1756,7 +1701,7 @@ char *ast_recvtext(struct ast_channel *c
 		if (f->frametype == AST_FRAME_CONTROL && f->subclass == AST_CONTROL_HANGUP)
 			done = 1;	/* force a break */
 		else if (f->frametype == AST_FRAME_TEXT) {	/* what we want */
-			buf = strndup((char *)f->data, f->datalen);	/* dup and break */
+			buf = ast_strndup(f->data, f->datalen);	/* dup and break */
 			done = 1;
 		}
 		ast_frfree(f);
Index: utils.c
===================================================================
RCS file: /usr/cvsroot/asterisk/utils.c,v
retrieving revision 1.53
diff -u -p -r1.53 utils.c
--- utils.c	24 Jun 2005 22:45:15 -0000	1.53
+++ utils.c	10 Jul 2005 21:14:32 -0000
@@ -493,6 +552,24 @@ int ast_false(const char *s)
 		return -1;
 
 	return 0;
+}
+
+char *ast_strndup(const char *src, int n)
+{
+	int i;
+	char *dst = NULL;
+
+	if (src == NULL)	/* safety check */
+		return dst;
+	for (i=0; i<n; i++)
+		if (src[i] == '\0')
+			break;
+	dst = malloc(i+1); /* actual length */
+	if (dst == NULL)
+		return dst;
+	memcpy(dst, src, i);
+	dst[i] = '\0';
+	return dst;
 }
 
 /* Case-insensitive substring matching */
Index: Makefile
===================================================================
RCS file: /usr/cvsroot/asterisk/Makefile,v
retrieving revision 1.176
diff -u -p -r1.176 Makefile
--- Makefile	10 Jul 2005 15:53:05 -0000	1.176
+++ Makefile	10 Jul 2005 21:14:33 -0000
@@ -235,7 +250,7 @@ LIBS+=-lresolv
 CFLAGS+=-D__Darwin__
 endif
 ifeq (${OSARCH},FreeBSD)
-LIBS+=-lcrypto -lstrfunc
+LIBS+=-lcrypto
 endif
 ifeq (${OSARCH},NetBSD)
 LIBS+=-lpthread -lcrypto -lm -L$(CROSS_COMPILE_TARGET)/usr/local/lib -L$(CROSS_COMPILE_TARGET)/usr/pkg/lib -lncurses
Index: include/asterisk/strings.h
===================================================================
RCS file: /usr/cvsroot/asterisk/include/asterisk/strings.h,v
retrieving revision 1.1
diff -u -p -r1.1 strings.h
--- include/asterisk/strings.h	24 Jun 2005 22:50:07 -0000	1.1
+++ include/asterisk/strings.h	10 Jul 2005 21:14:33 -0000
@@ -168,6 +168,11 @@ void ast_copy_string(char *dst, const ch
 #endif
 
 /*!
+ \brief same as strdup, but at most takes n characters and adds a NUL
+*/
+char *ast_strndup(const char *_src, int _n);
+
+/*!
   \brief Build a string in a buffer, designed to be called repeatedly
   
   This is a wrapper for snprintf, that properly handles the buffer pointer
